using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;

namespace Infragistics.Win.UltraWinTree.Samples
{
	#region UltraTreePropertyGrid class
	/// <summary>
	/// User control which uses the UltraTree control to present a read-only,
	/// PropertyGrid-like user interface for displaying the properties of
	/// an object.
	/// </summary>
	public class UltraTreePropertyGrid : UserControl
	{
		#region Member variables

		private System.Windows.Forms.Panel pnlDescription;
		private System.Windows.Forms.Splitter splitter1;
		private Infragistics.Win.UltraWinTree.UltraTree ultraTree1;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;
		private object _selectedObject = null;
		private Infragistics.Win.Misc.UltraLabel lblPropertyName;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel1;
		private Infragistics.Win.Misc.UltraLabel lblDescription;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsManager ultraToolbarsManager1;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _UltraTreePropertyGrid_Toolbars_Dock_Area_Left;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _UltraTreePropertyGrid_Toolbars_Dock_Area_Right;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _UltraTreePropertyGrid_Toolbars_Dock_Area_Top;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom;
		private ReflectionSupport _reflectionSupport = null;
		private bool categorized = false;

		#endregion Member variables

		#region Constructor
		/// <summary>
		/// Creates a new instance of the <see cref="ultraTreePropertyGrid"/> user control.
		/// </summary>
		public UltraTreePropertyGrid()
		{
			InitializeComponent();
		}
		#endregion Constructor

		#region Component Designer generated code

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(UltraTreePropertyGrid));
			Infragistics.Win.Appearance appearance1 = new Infragistics.Win.Appearance();
			Infragistics.Win.Appearance appearance2 = new Infragistics.Win.Appearance();
			Infragistics.Win.UltraWinTree.UltraTreeColumnSet ultraTreeColumnSet1 = new Infragistics.Win.UltraWinTree.UltraTreeColumnSet();
			Infragistics.Win.UltraWinToolbars.OptionSet optionSet1 = new Infragistics.Win.UltraWinToolbars.OptionSet("Main");
			Infragistics.Win.UltraWinToolbars.UltraToolbar ultraToolbar1 = new Infragistics.Win.UltraWinToolbars.UltraToolbar("UltraToolbar1");
			Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool1 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Categorized", "Main");
			Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool2 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Alphabetic", "Main");
			Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool3 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Categorized", "Main");
			Infragistics.Win.Appearance appearance3 = new Infragistics.Win.Appearance();
			Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool4 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Alphabetic", "Main");
			Infragistics.Win.Appearance appearance4 = new Infragistics.Win.Appearance();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.pnlDescription = new System.Windows.Forms.Panel();
			this.panel1 = new System.Windows.Forms.Panel();
			this.lblDescription = new Infragistics.Win.Misc.UltraLabel();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.lblPropertyName = new Infragistics.Win.Misc.UltraLabel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.ultraTree1 = new Infragistics.Win.UltraWinTree.UltraTree();
			this.ultraToolbarsManager1 = new Infragistics.Win.UltraWinToolbars.UltraToolbarsManager(this.components);
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Top = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
			this.pnlDescription.SuspendLayout();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.ultraTree1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.ultraToolbarsManager1)).BeginInit();
			this.SuspendLayout();
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// pnlDescription
			// 
			this.pnlDescription.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.panel1,
																						 this.splitter2,
																						 this.lblPropertyName});
			this.pnlDescription.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlDescription.Location = new System.Drawing.Point(0, 232);
			this.pnlDescription.Name = "pnlDescription";
			this.pnlDescription.Size = new System.Drawing.Size(232, 80);
			this.pnlDescription.TabIndex = 1;
			// 
			// panel1
			// 
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.lblDescription});
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 17);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(232, 63);
			this.panel1.TabIndex = 3;
			// 
			// lblDescription
			// 
			appearance1.BorderColor = System.Drawing.SystemColors.ControlDark;
			this.lblDescription.Appearance = appearance1;
			this.lblDescription.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lblDescription.Name = "lblDescription";
			this.lblDescription.Size = new System.Drawing.Size(232, 63);
			this.lblDescription.TabIndex = 1;
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Enabled = false;
			this.splitter2.Location = new System.Drawing.Point(0, 16);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(232, 1);
			this.splitter2.TabIndex = 2;
			this.splitter2.TabStop = false;
			// 
			// lblPropertyName
			// 
			appearance2.FontData.BoldAsString = "True";
			this.lblPropertyName.Appearance = appearance2;
			this.lblPropertyName.Dock = System.Windows.Forms.DockStyle.Top;
			this.lblPropertyName.Name = "lblPropertyName";
			this.lblPropertyName.Size = new System.Drawing.Size(232, 16);
			this.lblPropertyName.TabIndex = 1;
			// 
			// splitter1
			// 
			this.splitter1.BackColor = System.Drawing.SystemColors.ControlDark;
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 230);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(232, 2);
			this.splitter1.TabIndex = 2;
			this.splitter1.TabStop = false;
			// 
			// ultraTree1
			// 
			this.ultraTree1.BorderStyle = Infragistics.Win.UIElementBorderStyle.None;
			this.ultraTree1.ColumnSettings.RootColumnSet = ultraTreeColumnSet1;
			this.ultraTree1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.ultraTree1.Location = new System.Drawing.Point(0, 53);
			this.ultraTree1.Name = "ultraTree1";
			this.ultraTree1.Size = new System.Drawing.Size(232, 177);
			this.ultraTree1.TabIndex = 3;
			this.ultraTree1.AfterSelect += new Infragistics.Win.UltraWinTree.AfterNodeSelectEventHandler(this.ultraTree1_AfterSelect);
			// 
			// ultraToolbarsManager1
			// 
			this.ultraToolbarsManager1.DesignerFlags = 1;
			this.ultraToolbarsManager1.DockWithinContainer = this;
			this.ultraToolbarsManager1.ImageSizeSmall = new System.Drawing.Size(20, 20);
			this.ultraToolbarsManager1.ImageTransparentColor = System.Drawing.Color.Magenta;
			optionSet1.AllowAllUp = false;
			this.ultraToolbarsManager1.OptionSets.Add(optionSet1);
			this.ultraToolbarsManager1.ShowFullMenusDelay = 500;
			ultraToolbar1.DockedColumn = 0;
			ultraToolbar1.DockedRow = 0;
			ultraToolbar1.Text = "UltraToolbar1";
			stateButtonTool2.Checked = true;
			ultraToolbar1.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
																							  stateButtonTool1,
																							  stateButtonTool2});
			this.ultraToolbarsManager1.Toolbars.AddRange(new Infragistics.Win.UltraWinToolbars.UltraToolbar[] {
																												  ultraToolbar1});
			this.ultraToolbarsManager1.ToolbarSettings.AllowCustomize = Infragistics.Win.DefaultableBoolean.False;
			stateButtonTool3.OptionSetKey = "Main";
			appearance3.Image = ((System.Drawing.Bitmap)(resources.GetObject("appearance3.Image")));
			stateButtonTool3.SharedProps.AppearancesSmall.Appearance = appearance3;
			stateButtonTool3.SharedProps.Caption = "&Categorized";
			stateButtonTool3.SharedProps.ToolTipText = "Sort entries by category";
			stateButtonTool4.Checked = true;
			stateButtonTool4.OptionSetKey = "Main";
			appearance4.Image = ((System.Drawing.Bitmap)(resources.GetObject("appearance4.Image")));
			stateButtonTool4.SharedProps.AppearancesSmall.Appearance = appearance4;
			stateButtonTool4.SharedProps.Caption = "&Alphabetic";
			stateButtonTool4.SharedProps.ToolTipText = "Sort entries alphabetically";
			this.ultraToolbarsManager1.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
																										   stateButtonTool3,
																										   stateButtonTool4});
			this.ultraToolbarsManager1.ToolClick += new Infragistics.Win.UltraWinToolbars.ToolClickEventHandler(this.ultraToolbarsManager1_ToolClick);
			// 
			// _UltraTreePropertyGrid_Toolbars_Dock_Area_Left
			// 
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left.BackColor = System.Drawing.SystemColors.Control;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Left;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left.ForeColor = System.Drawing.SystemColors.ControlText;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left.Location = new System.Drawing.Point(0, 53);
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left.Name = "_UltraTreePropertyGrid_Toolbars_Dock_Area_Left";
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left.Size = new System.Drawing.Size(0, 259);
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left.ToolbarsManager = this.ultraToolbarsManager1;
			// 
			// _UltraTreePropertyGrid_Toolbars_Dock_Area_Right
			// 
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right.BackColor = System.Drawing.SystemColors.Control;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Right;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right.ForeColor = System.Drawing.SystemColors.ControlText;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right.Location = new System.Drawing.Point(232, 53);
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right.Name = "_UltraTreePropertyGrid_Toolbars_Dock_Area_Right";
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right.Size = new System.Drawing.Size(0, 259);
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right.ToolbarsManager = this.ultraToolbarsManager1;
			// 
			// _UltraTreePropertyGrid_Toolbars_Dock_Area_Top
			// 
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Top.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Top.BackColor = System.Drawing.SystemColors.Control;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Top.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Top;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Top.ForeColor = System.Drawing.SystemColors.ControlText;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Top.Name = "_UltraTreePropertyGrid_Toolbars_Dock_Area_Top";
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Top.Size = new System.Drawing.Size(232, 53);
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Top.ToolbarsManager = this.ultraToolbarsManager1;
			// 
			// _UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom
			// 
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom.BackColor = System.Drawing.SystemColors.Control;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Bottom;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom.ForeColor = System.Drawing.SystemColors.ControlText;
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom.Location = new System.Drawing.Point(0, 312);
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom.Name = "_UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom";
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom.Size = new System.Drawing.Size(232, 0);
			this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom.ToolbarsManager = this.ultraToolbarsManager1;
			// 
			// UltraTreePropertyGrid
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.ultraTree1,
																		  this.splitter1,
																		  this.pnlDescription,
																		  this._UltraTreePropertyGrid_Toolbars_Dock_Area_Left,
																		  this._UltraTreePropertyGrid_Toolbars_Dock_Area_Right,
																		  this._UltraTreePropertyGrid_Toolbars_Dock_Area_Top,
																		  this._UltraTreePropertyGrid_Toolbars_Dock_Area_Bottom});
			this.Name = "UltraTreePropertyGrid";
			this.Size = new System.Drawing.Size(232, 312);
			this.pnlDescription.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.ultraTree1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.ultraToolbarsManager1)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		#region Properties

			#region SelectedObject
		/// <summary>
		/// Gets/sets the selected object.
		/// </summary>
		public object SelectedObject
		{
			get{ return this._selectedObject; }
			set
			{ 
				this._selectedObject = value; 
				this.PopulateTree();
			}
		}
			#endregion SelectedObject

			#region ReflectionSupport
		/// <summary>
		/// Returns the ReflectionSupport instance for this <see cref="ultraTreePropertyGrid"/> instance.
		/// </summary>
		private ReflectionSupport ReflectionSupport
		{
			get
			{ 
				if ( this._reflectionSupport == null && this._selectedObject != null )
					this._reflectionSupport = new ReflectionSupport( this._selectedObject );

				return this._reflectionSupport; 
			}
		}
			#endregion ReflectionSupport

		#endregion Properties

		#region Methods

			#region PopulateTree
		/// <summary>
		/// Called when the <see cref="SelectedObject"/> property is set to a new value.
		/// </summary>
		private void PopulateTree()
		{
			//	Set the cursor to the wait cursor while the tree is being populated
			Cursor.Current = Cursors.WaitCursor;

			//	Clear the UltraTree from the previous SelectedObject
			this.ultraTree1.Nodes.Clear();
			UltraTreeColumnSet rootColumnSet = this.ultraTree1.ColumnSettings.RootColumnSet;
			rootColumnSet.Columns.Clear();
			this._reflectionSupport = null;

			if ( this._selectedObject == null )
				return;

			//	Use the 'OutlookExpress' ViewStyle; reduce indentation a little
			this.ultraTree1.ViewStyle = ViewStyle.OutlookExpress;
			this.ultraTree1.Indent = 15;

			//	Only allow one node to be selected at a time
			this.ultraTree1.Override.SelectionType = SelectType.Single;
			
			//	Use single-pixel borders of 'Control' color for the cells
			this.ultraTree1.ColumnSettings.BorderStyleCell = UIElementBorderStyle.Solid;
			this.ultraTree1.ColumnSettings.CellAppearance.BorderColor = SystemColors.Control;

			//	Hide the headers
			this.ultraTree1.ColumnSettings.LabelPosition = NodeLayoutLabelPosition.None;

			//	Add 2 columns - one for the name of the property, and one for its value
			//	Set the data type for the columns, and the width
			UltraTreeNodeColumn colName = rootColumnSet.Columns.Add( "Name" );
			colName.DataType = typeof(string);
			colName.LayoutInfo.PreferredCellSize = new Size( this.Width / 2, 0 );

			UltraTreeNodeColumn colValue = rootColumnSet.Columns.Add( "Value" );
			colValue.DataType = typeof(object);
			colValue.LayoutInfo.PreferredCellSize = new Size( this.Width / 2, 0 );

			//	Add a column for the property's description, and hide it
			UltraTreeNodeColumn colDescription = rootColumnSet.Columns.Add( "Description" );
			colDescription.Visible = false;

			//	Auto-fit columns
			this.ultraTree1.ColumnSettings.AutoFitColumns = AutoFitColumns.ResizeAllColumns;

			//	If the view is by category, add root-level nodes to represent
			//	each category, assigning the name of the category to their key.
			if ( this.categorized )
			{
				for ( int i = 0; i < this.ReflectionSupport.PropertyNames.Length; i ++ )
				{
					//	Get the property's name and category
					string propertyName = this.ReflectionSupport.PropertyNames[i];
					string category = this.ReflectionSupport.GetPropertyCategory( propertyName );
	
					//	We only want one node for each category, so skip this iteration
					//	if we already have a node for this category.
					if ( category.Length == 0 || this.ultraTree1.Nodes.Exists(category) )
						continue;
					
					//	Add a node to represent the category
					this.AddCategoryNode( category, rootColumnSet );
				}
			}

			//	Populate the tree with the names of the design-time visible properties
			for ( int i = 0; i < this.ReflectionSupport.PropertyNames.Length; i ++ )
			{
				//	Get the property's name, description, and category
				string propertyName = this.ReflectionSupport.PropertyNames[i];
				string description = this.ReflectionSupport.GetPropertyDescription( propertyName );
				string category = this.ReflectionSupport.GetPropertyCategory( propertyName );

				//	Add the node to the root nodes collection, or the appropriate
				//	category node, depending on the view
				UltraTreeNode node = null;
				if ( this.categorized && category.Length > 0 )
				{
					UltraTreeNode rootNode = this.ultraTree1.GetNodeByKey( category );
					node = rootNode.Nodes.Add( null, propertyName );
				}
				else
				if ( this.categorized == false )
					node = this.ultraTree1.Nodes.Add( null, propertyName );

				if ( node == null )
					continue;

				//	Set the 'Name' cell value
				node.SetCellValue( colName, propertyName );

				//	Set the 'Value' cell value
				object propertyValue = this.ReflectionSupport.GetPropertyValue( propertyName );
				node.SetCellValue( colValue, propertyValue );

                //	Set the 'Description' cell value
                node.SetCellValue(colDescription, description);

				//	Add nodes to represent the sub-objects for this node
				this.AddSubObjects( node, propertyValue, rootColumnSet );
			}

			//	Sort the nodes; if sorting by category, use a custom SortComparer,
			//	otherwise, sort in ascending order.
			if ( this.categorized )
				colName.SortComparer = new CategoricalSortComparer();

			colName.SortType = SortType.Ascending;

			//	If categorized, expand all root nodes
			if ( this.categorized )
			{
				for ( int i = 0; i < this.ultraTree1.Nodes.Count; i ++ )
				{
					this.ultraTree1.Nodes[i].Expanded = true;
				}
			}

			//	Restore the cursor
			Cursor.Current = Cursors.Default;
		}
			#endregion PopulateTree

			#region AddCategoryNode
		/// <summary>
		/// Adds a node to the root nodes collection for the specified category.
		/// </summary>
		private void AddCategoryNode( string categoryName, UltraTreeColumnSet columnSet )
		{
			UltraTreeNodeColumn colName = columnSet.Columns["Name"];
			UltraTreeNodeColumn colValue = columnSet.Columns["Value"];

			//	Add the node
			UltraTreeNode node = this.ultraTree1.Nodes.Add( categoryName );

			//	Set the 'Name' cell to display the name of the category
			node.SetCellValue( colName, categoryName );

			//	Set the appearance properties
			UltraTreeNodeCell cellName = node.Cells[ colName ];
			UltraTreeNodeCell cellValue = node.Cells[ colValue ];

			cellName.Appearance.BackColor = SystemColors.ControlDark;
			cellName.Appearance.ForeColor = SystemColors.ControlDarkDark;
			cellName.Appearance.FontData.Bold = DefaultableBoolean.True;
			cellName.Appearance.BorderColor = Color.Transparent;

			cellValue.Appearance.BackColor = SystemColors.ControlDark;
			cellValue.Appearance.BorderColor = Color.Transparent;
		}
			#endregion AddCategoryNode

			#region AddSubObjects
		/// <summary>
		/// Adds the specified subObject to the property tree
		/// </summary>
		private void AddSubObjects( UltraTreeNode node, object subObject, UltraTreeColumnSet columnSet )
		{
			if ( node == null || subObject == null || subObject is UltraTree )
				return;

			UltraTreeNodeColumn nameColumn = columnSet.Columns["Name"];
			UltraTreeNodeColumn valueColumn = columnSet.Columns["Value"];
			UltraTreeNodeColumn descriptionColumn = columnSet.Columns["Description"];

			//	Don't bother with value types or strings
			Type type = subObject.GetType();
			if ( type.IsClass == false || type == typeof(string) )
				return;

			//	Iterate the members (if any) of the specified sub-object,
			//	and call this method recursively on those members to get
			//	their sub-objects, and so on.
			ReflectionSupport reflection = new ReflectionSupport( subObject );
			for ( int i = 0; i < reflection.PropertyNames.Length; i ++ )
			{
				//	Get the name of the property
				string propertyName = reflection.PropertyNames[i];
				object propertyValue = reflection.GetPropertyValue( propertyName );
				string propertyDescription = reflection.GetPropertyDescription( propertyName );

				//	To prevent infinite recursion, make sure that this will
				//	not create a circular reference
				if ( this.VerifySubObject(node, valueColumn, propertyValue) == false )
					continue;

				//	Add a node for the property
				UltraTreeNode subNode = node.Nodes.Add( null, propertyName );

				//	Set the value of the 'Name', 'Value' and 'Description' columns' cells
				subNode.SetCellValue( nameColumn, propertyName );
				subNode.SetCellValue( valueColumn, propertyValue );
				subNode.SetCellValue( descriptionColumn, propertyDescription );

				//	Call this method recursively to drill down the object hierarchy
				this.AddSubObjects( subNode, propertyValue, columnSet );
			}

		}
			#endregion AddSubObjects

			#region VerifySubObject
		/// <summary>
		/// Verifies the specified propertyValue by returning false if it
		/// references an instance of the same class found somewhere in the
		/// specified node's ancestor chain.
		/// </summary>
		private bool VerifySubObject( UltraTreeNode node, UltraTreeNodeColumn valueColumn, object propertyValue )
		{
			UltraTreeNode parentNode = node;
			while( parentNode != null )
			{
				object cellVal = parentNode.GetCellValue( valueColumn );
				if ( cellVal == propertyValue )
					return false;

				parentNode = parentNode.Parent;
			}

			return true;
		}
			#endregion VerifySubObject

		#endregion Methods

		#region Event handlers

		/// <summary>
		/// Handles the UltraTree's 'AfterSelect' event
		/// </summary>
		private void ultraTree1_AfterSelect(object sender, Infragistics.Win.UltraWinTree.SelectEventArgs e)
		{
			if ( e.NewSelections.Count == 1 )
			{
				UltraTreeNode node = e.NewSelections[0];

				//	We don't want to do this for category nodes
				if ( node.Key == null || node.Key.Length == 0 )
				{
					UltraTreeNodeColumn colDescription = node.DisplayColumnSetResolved.Columns["Description"];
					string description = node.GetCellValue( colDescription ) as string;
					this.lblPropertyName.Text = node.Text;
					this.lblDescription.Text = description;
				}
			}
		}

		/// <summary>
		/// Handles the UltraToolbarsManager's 'ToolClick' event
		/// </summary>
		private void ultraToolbarsManager1_ToolClick(object sender, Infragistics.Win.UltraWinToolbars.ToolClickEventArgs e)
		{
			if ( e.Tool.Key == "Categorized" || e.Tool.Key == "Alphabetic" )
			{
				this.categorized = (e.Tool.Key == "Categorized");
				this.PopulateTree();
			}
		}

		#endregion Event handlers

	}
	#endregion UltraTreePropertyGrid class

	#region CategoricalSortComparer class
	/// <summary>
	/// IComparer implementor used for sorting nodes by their 'Category' attribute
	/// </summary>
	internal class CategoricalSortComparer : IComparer
	{
		internal CategoricalSortComparer()
		{
		}

		int IComparer.Compare( object x, object y )
		{
			UltraTreeNodeCell cellX = x as UltraTreeNodeCell;
			UltraTreeNodeCell cellY = y as UltraTreeNodeCell;

			string valX = cellX != null ? cellX.Value as string : null;
			string valY = cellY != null ? cellY.Value as string : null;

			if ( valX == null && valY == null )
				return 0;
			else
			if ( valX == null )
				return -1;
			else
			if ( valY == null )
				return 1;

			//	Get a reference to each cell's node
			UltraTreeNode nodeX = cellX.Node;
			UltraTreeNode nodeY = cellY.Node;
			
			//	For level 1 and deeper, sort alphabetically
			if ( nodeX.Level >= 1 )
				return valX.CompareTo( valY );
			
			//	For level 0, sort by the node's Key, which contains its Category.
			valX = nodeX.Key;
			valY = nodeY.Key;
			return valX.CompareTo( valY );
		}
	}
	#endregion CategoricalSortComparer class
}
